// Generated by gencpp from file teleop_msgs/PFParamsRequest.msg
// DO NOT EDIT!


#ifndef TELEOP_MSGS_MESSAGE_PFPARAMSREQUEST_H
#define TELEOP_MSGS_MESSAGE_PFPARAMSREQUEST_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace teleop_msgs
{
template <class ContainerAllocator>
struct PFParamsRequest_
{
  typedef PFParamsRequest_<ContainerAllocator> Type;

  PFParamsRequest_()
    : d_ac(0.0)
    , K_ac()
    , B_ac()
    , K_ac_obs()
    , B_ac_obs()  {
    }
  PFParamsRequest_(const ContainerAllocator& _alloc)
    : d_ac(0.0)
    , K_ac(_alloc)
    , B_ac(_alloc)
    , K_ac_obs(_alloc)
    , B_ac_obs(_alloc)  {
  (void)_alloc;
    }



   typedef double _d_ac_type;
  _d_ac_type d_ac;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _K_ac_type;
  _K_ac_type K_ac;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _B_ac_type;
  _B_ac_type B_ac;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _K_ac_obs_type;
  _K_ac_obs_type K_ac_obs;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _B_ac_obs_type;
  _B_ac_obs_type B_ac_obs;





  typedef boost::shared_ptr< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> const> ConstPtr;

}; // struct PFParamsRequest_

typedef ::teleop_msgs::PFParamsRequest_<std::allocator<void> > PFParamsRequest;

typedef boost::shared_ptr< ::teleop_msgs::PFParamsRequest > PFParamsRequestPtr;
typedef boost::shared_ptr< ::teleop_msgs::PFParamsRequest const> PFParamsRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::teleop_msgs::PFParamsRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::teleop_msgs::PFParamsRequest_<ContainerAllocator1> & lhs, const ::teleop_msgs::PFParamsRequest_<ContainerAllocator2> & rhs)
{
  return lhs.d_ac == rhs.d_ac &&
    lhs.K_ac == rhs.K_ac &&
    lhs.B_ac == rhs.B_ac &&
    lhs.K_ac_obs == rhs.K_ac_obs &&
    lhs.B_ac_obs == rhs.B_ac_obs;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::teleop_msgs::PFParamsRequest_<ContainerAllocator1> & lhs, const ::teleop_msgs::PFParamsRequest_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace teleop_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cad41f1d05c351f017d7d4b275e655cb";
  }

  static const char* value(const ::teleop_msgs::PFParamsRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xcad41f1d05c351f0ULL;
  static const uint64_t static_value2 = 0x17d7d4b275e655cbULL;
};

template<class ContainerAllocator>
struct DataType< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "teleop_msgs/PFParamsRequest";
  }

  static const char* value(const ::teleop_msgs::PFParamsRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 d_ac\n"
"float64[] K_ac\n"
"float64[] B_ac\n"
"float64[] K_ac_obs\n"
"float64[] B_ac_obs\n"
;
  }

  static const char* value(const ::teleop_msgs::PFParamsRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.d_ac);
      stream.next(m.K_ac);
      stream.next(m.B_ac);
      stream.next(m.K_ac_obs);
      stream.next(m.B_ac_obs);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct PFParamsRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::teleop_msgs::PFParamsRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::teleop_msgs::PFParamsRequest_<ContainerAllocator>& v)
  {
    s << indent << "d_ac: ";
    Printer<double>::stream(s, indent + "  ", v.d_ac);
    s << indent << "K_ac[]" << std::endl;
    for (size_t i = 0; i < v.K_ac.size(); ++i)
    {
      s << indent << "  K_ac[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.K_ac[i]);
    }
    s << indent << "B_ac[]" << std::endl;
    for (size_t i = 0; i < v.B_ac.size(); ++i)
    {
      s << indent << "  B_ac[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.B_ac[i]);
    }
    s << indent << "K_ac_obs[]" << std::endl;
    for (size_t i = 0; i < v.K_ac_obs.size(); ++i)
    {
      s << indent << "  K_ac_obs[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.K_ac_obs[i]);
    }
    s << indent << "B_ac_obs[]" << std::endl;
    for (size_t i = 0; i < v.B_ac_obs.size(); ++i)
    {
      s << indent << "  B_ac_obs[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.B_ac_obs[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // TELEOP_MSGS_MESSAGE_PFPARAMSREQUEST_H
